Comment by Solar Designer \ BPC '96 ;) 
Tiny CRC-32 Routine for 80x86 
Ripped out of PKUNZJR.COM (version 2.04g) by Solar Designer \ BPC '96 
  
.model large, pascal
.code
assume cs:@code, ds:@data, es:@data 

public InitCRC32, UpdateCRC32
extrn TableCRC32 

; InitCRC32 routine generates the table to use by UpdateCRC32 routine. It is 
; not optimized for speed because it should run only once and it takes less 
; than 1ms on a 486.  

InitCRC32 Proc Far 

push ds
pop  es 
std
mov  di,offset TableCRC32 + 256*4/2 - 2 
mov  bx,0FFh

TableLoop:
mov  cx,8
mov  dx,bx 
xor  ax,ax

InnerLoop:
shr  ax,1
rcr  dx,1
jnc  NoCarry 
xor  dx,8320h
xor  ax,0EDB8h
NoCarry: 
loop InnerLoop 

; Here we keep odd & even words separately. That was not implemented in
; PKUNZJR.COM, but I decided to implement it here because it makes 5%
; speedup of UpdateCRC32 routine with cost of only 1 byte. 

mov  [di+200h],dx 
stosw
dec  bx 
jns  TableLoop
ret 

EndP 

; UpdateCRC32 routine updates the 32-bit CRC value passed to it and returns
; the new CRC value in DX:AX 

UpdateCRC32 Proc Uses DS, CRC:DWord, Buffer:DWord, Count:Word  

les  cx,CRC 
mov  dx,es 
lds  si,Buffer
mov  bp,Count 
mov  di,offset TableCRC32
cld
xor  ax,ax
inc  bp
jmp  short StartLoop 

Even 

ByteLoop:
lodsb
mov  bx,ax
xor  bl,cl
mov  cl,ch
mov  ch,dl
mov  dl,dh
mov  dh,bh
add  bx,bx 
xor  cx,[bx+di+200h]
xor  dx,[bx+di]

StartLoop:
dec  bp
jnz  ByteLoop
 
xchg ax,cx
ret 

EndP 

end
